
/*
  Horloge  CI DS3231 et Afficheur TFT LCD Tactile 2.4 inch
                Arduino 
 
CI DS3232
VDD  3VCC ou 5VCC  
SDA  A4
SCL  A5
             

  Mon site http://f5mna .free.fr

  Mai 2016
*/


#include <SPFD5408_Adafruit_GFX.h>    // Core graphics library
#include <SPFD5408_Adafruit_TFTLCD.h> // Hardware-specific library
#include <TouchScreen.h>
#include <math.h>
#include <Wire.h>
#include <DS1307new.h>
///////////////////  Afficheur ///////////////////////////

#define YP A3
#define XM A2
#define YM 9
#define XP 8
#define TS_MINX 150
#define TS_MINY 120
#define TS_MAXX 950
#define TS_MAXY 940
TouchScreen ts = TouchScreen(XP, YP, XM, YM, 300);
#define LCD_CS A3
#define LCD_CD A2
#define LCD_WR A1
#define LCD_RD A0
#define LCD_RESET A4
#define  BLACK   0x0000
#define BLUE    0x001F
#define RED     0xF800
#define GREEN   0x07E0
#define CYAN    0x07FF
#define MAGENTA 0xF81F
#define YELLOW  0xFFE0
#define WHITE   0xFFFF
#define MINPRESSURE 10
#define MAXPRESSURE 1000
Adafruit_TFTLCD tft(LCD_CS, LCD_CD, LCD_WR, LCD_RD, LCD_RESET);
////////////////////////////////////////////////////////////

//DS3232


//////////////////////////////////////////////////
int I2C_DS3232 = 0xD0 >> 1;
byte DS3232control = 0b00011100, DS3232status = 0b11001000 , DS3232aging , DS3232Msb , DS3232Lsb;
//////////////////////////////////////////////////
uint16_t startAddr = 0x0000;       // Adresse de démarrage Start dans  NV-RAM
uint16_t lastAddr;                 // Nelle addresse des stockage NV-RAM
uint16_t TimeIsSet = 0xaa55;       // Prévient qu'il n'y a pas de remise à l'heure

// DDS/Arduino Connections
#define DDS_LOAD  12  //FQ_UD
#define DDS_CLOCK 3
#define DDS_DATA  2
/*
  CI DS3231 sur Arduino Mega
  VDD  3VCC ou 5VCC
  SDA  21
  SCL  20
*/
///////////////////////////////////////////////////////////////////////////////////////
int a, angles, anglem, angleh, Xs, Ys, Xs1, Ys1, Xs2, Ys2, Xm, Ym, Xm1, Ym1,
    Xm2, Ym2, Xh, Yh, Xh1, Yh1, Xh2, Yh2, Reg, Sort, second1, minute1, hour1, jour1;
float rad;
int Heure;
int Minute;
int Seconde;
int Jour;
int Annee;
int JourSem;


//////////////////////////////////////////////////////////////////////////////////////////////////////
void setup () {

  Serial.begin(9600);
  Serial.println("http://f5mna.free.fr");

  // pinMode(2, INPUT);                    // Test  SQW pin, D2 = INPUT
  // digitalWrite(2, HIGH);                // Test  SQW pin, D2 = Pullup on

  RTC.setRAM(0, (uint8_t *)&startAddr, sizeof(uint16_t));// Entree startAddr in NV-RAM address 0x08
  TimeIsSet = 0xffff;
  RTC.setRAM(54, (uint8_t *)&TimeIsSet, sizeof(uint16_t));
  RTC.ctrl = 0x00;     // 0x00=disable SQW pin, 0x10=1Hz,
  // 0x11=4096Hz, 0x12=8192Hz, 0x13=32768Hz

  RTC.getTime();

  ///// Cadran ////////////
  rad = ((2 * 3.1415926536) / 360);
  tft.begin(0x9341); // SDFP5408
  tft.fillScreen(BLACK);

  tft.setRotation(4);
  tft.fillCircle(120, 90, 60, tft.color565(208, 242, 255));
  tft.drawCircle(120, 90, 60, BLUE);
  tft.drawCircle(120, 90, 63, CYAN);
  tft.drawCircle(120, 90, 66, tft.color565(208, 242, 255));

  for (int x = 0; x < 12; x++) {
    Xs = 120 + (cos((x * 30) * rad) * 75);
    Ys = 90 + (sin((x * 30) * rad) * 75);
    tft.drawLine(120, 90, Xs, Ys, tft.color565(208, 242, 255));
  }

  for (int x = 0; x < 60; x++) {
    Xs = 120 + (cos((x * 6) * rad) * 65);
    Ys = 90 + (sin((x * 6) * rad) * 65);
    tft.drawLine(120, 90, Xs, Ys, tft.color565(208, 242, 255));
  }

  //tft.setCursor(120, 0);
  tft.setTextColor(CYAN);  tft.setTextSize(2);
  tft.setCursor(110, 5);
  tft.println("12");
  tft.setCursor(200, 83);
  tft.println("3");
  tft.setCursor(116, 170);
  tft.println("6");

  tft.setCursor(30, 82);
  tft.println("9");
  Reg = 1;
}

void Marche()
{
  RTC.getTime();
  tft.drawCircle(120, 90, 5, BLACK);
  tft.fillCircle(120, 90, 3, BLACK);
  tft.setTextColor(GREEN);  tft.setTextSize(2);
  tft.setCursor(200, 290);
  tft.println(" R ");

  // Secondes
  angles = (RTC.second - 15) * 6;
  Xs = 120 + (cos(angles * rad) * 60);
  Ys = 90 + (sin(angles * rad) * 60);
  Xs1 = 120 + (cos((angles + 2) * rad) * 50);
  Ys1 = 90 + (sin((angles + 2) * rad) * 50);
  Xs2 = 120 + (cos((angles - 2) * rad) * 50);
  Ys2 = 90 + (sin((angles - 2) * rad) * 50);
  tft.drawLine(120, 90, Xs, Ys, RED);
  tft.drawLine(120, 90, Xs1, Ys1, RED);
  tft.drawLine( Xs1, Ys1, Xs, Ys, RED);
  tft.drawLine(120, 90, Xs2, Ys2, RED);
  tft.drawLine( Xs2, Ys2, Xs, Ys, RED);

  Xs = 120 + (cos((angles - 6) * rad) * 60);
  Ys = 90 + (sin((angles - 6) * rad) * 60);
  Xs1 = 120 + (cos((angles - 8) * rad) * 50);
  Ys1 = 90 + (sin((angles - 8) * rad) * 50);
  Xs2 = 120 + (cos((angles - 4) * rad) * 50);
  Ys2 = 90 + (sin((angles - 4) * rad) * 50);
  tft.drawLine(120, 90, Xs, Ys, tft.color565(208, 242, 255));
  tft.drawLine(120, 90, Xs1, Ys1, tft.color565(208, 242, 255));
  tft.drawLine( Xs1, Ys1, Xs, Ys, tft.color565(208, 242, 255));
  tft.drawLine(120, 90, Xs2, Ys2, tft.color565(208, 242, 255));
  tft.drawLine( Xs2, Ys2, Xs, Ys, tft.color565(208, 242, 255));

  // Minutes
  anglem = (RTC.minute - 15) * 6 ;
  Xm = 120 + (cos(anglem * rad) * 50);
  Ym = 90 + (sin(anglem * rad) * 50);
  Xm1 = 120 + (cos((anglem + 2) * rad) * 40);
  Ym1 = 90 + (sin((anglem + 2) * rad) * 40);
  Xm2 = 120 + (cos((anglem - 2) * rad) * 40);
  Ym2 = 90 + (sin((anglem - 2) * rad) * 40);
  tft.drawLine(120, 90, Xm, Ym, BLACK);
  tft.drawLine(120, 90, Xm1, Ym1, BLACK);
  tft.drawLine( Xm1, Ym1, Xm, Ym, BLACK);
  tft.drawLine(120, 90, Xm2, Ym2, BLACK);
  tft.drawLine( Xm2, Ym2, Xm, Ym, BLACK);

  Xm = 120 + (cos((anglem - 6) * rad) * 50);
  Ym = 90 + (sin((anglem - 6) * rad) * 50);
  Xm1 = 120 + (cos((anglem - 8) * rad) * 40);
  Ym1 = 90 + (sin((anglem - 8) * rad) * 40);
  Xm2 = 120 + (cos((anglem - 4) * rad) * 40);
  Ym2 = 90 + (sin((anglem - 4) * rad) * 40);
  tft.drawLine(120, 90, Xm, Ym, tft.color565(208, 242, 255));
  tft.drawLine(120, 90, Xm1, Ym1, tft.color565(208, 242, 255));
  tft.drawLine( Xm1, Ym1, Xm, Ym, tft.color565(208, 242, 255));
  tft.drawLine(120, 90, Xm2, Ym2, tft.color565(208, 242, 255));
  tft.drawLine( Xm2, Ym2, Xm, Ym, tft.color565(208, 242, 255));

  //heures
  angleh =  (((RTC.hour - 3) * 30) + ((anglem + 90) / 12));
  Xh = 120 + (cos(angleh * rad) * 40);
  Yh = 90 + (sin(angleh * rad) * 40);
  Xh1 = 120 + (cos((angleh + 3) * rad) * 30);
  Yh1 = 90 + (sin((angleh + 3) * rad) * 30);
  Xh2 = 120 + (cos((angleh - 3) * rad) * 30);
  Yh2 = 90 + (sin((angleh - 3) * rad) * 30);
  tft.drawLine(120, 90, Xh, Yh, BLACK);
  tft.drawLine(120, 90, Xh1, Yh1, BLACK);
  tft.drawLine( Xh1, Yh1, Xh, Yh, BLACK);
  tft.drawLine(120, 90, Xh2, Yh2, BLACK);
  tft.drawLine( Xh2, Yh2, Xh, Yh, BLACK);

  Xh = 120 + (cos((angleh - 30) * rad) * 40);
  Yh = 90 + (sin((angleh - 30) * rad) * 40);
  Xh1 = 120 + (cos((angleh - 33) * rad) * 30);
  Yh1 = 90 + (sin((angleh - 33) * rad) * 30);
  Xh2 = 120 + (cos((angleh - 27) * rad) * 30);
  Yh2 = 90 + (sin((angleh - 27) * rad) * 30);
  tft.drawLine(120, 90, Xh, Yh, tft.color565(208, 242, 255));
  tft.drawLine(120, 90, Xh1, Yh1, tft.color565(208, 242, 255));
  tft.drawLine( Xh1, Yh1, Xh, Yh, tft.color565(208, 242, 255));
  tft.drawLine(120, 90, Xh2, Yh2, tft.color565(208, 242, 255));
  tft.drawLine( Xh2, Yh2, Xh, Yh, tft.color565(208, 242, 255));



  if (RTC.dow != jour1) {
    tft.fillRect(30, 239, 180, 20, BLACK); // x, y, Long , haut// x, y, Long , haut
    tft.fillRect(74, 264, 120, 20,BLACK);}


  {
    tft.setTextColor(YELLOW);
    tft.setCursor(40, 240);
    tft.print(RTC.day, DEC);

    switch (RTC.month) {
      case 1:
        tft.print("Janvier ");
        break;
      case 2:
        tft.print("fevrier ");
        break;
      case 3:
        tft.print( "  mars  ");
        break;
      case 4:
        tft.print("  avril  ");
        break;
      case 5:
        tft.print( "   mai  ");
        break;
      case 6:
        tft.print("   juin  ");
        break;
      case 7:
        tft.print(" Juillet ");
        break;
      case 8:
        tft.print("  aout   ");
        break;
      case 9:
        tft.print("septembre");
        break;
      case 10:
        tft.print("octobre ");
        break;
      case 11:
        tft.print("Novembre ");
        break;
      case 12:
        tft.print("Decembre");
        break;
    }


    /////////////////////////////////////////////////////////////////////////
    tft.print(RTC.year, DEC);
    //  Jour
    tft.setCursor(75, 265);



    switch (RTC.dow) {
      case 1:
        tft.print (" Lundi  ");
        break;
      case 2:
        tft.print (" Mardi  ");
        break;
      case 3:
        tft.print ("Mercredi");
        break;
      case 4:
        tft.print (" Jeudi  ");
        break;
      case 5:
        tft.print ("Vendredi");
        break;
      case 6:
        tft.print (" Samedi ");
        break;
      case 0:
        tft.print ("Dimanche");
        break;
    }
  }

  tft.setTextSize(4);
  //--------------------------------------------------------------------

  //Heure Num


  if (RTC.hour != hour1) {
    if (RTC.hour < 10) {
      tft.fillRect(29, 197, 27, 36, BLACK);
      tft.setCursor(30, 197);
      tft.print ("0");
      tft.fillRect(55, 197, 23, 36, BLACK); // x, y, Long , haut
      tft.setCursor(56, 197);
      tft.print (RTC.hour);
    }
    else
    {
      tft.fillRect(29, 197, 50, 35, BLACK);
      tft.setCursor(30, 197);
      tft.print (RTC.hour);
    }
  }


  //--------------------------------------------------------------------

  //Minute Num
  if (RTC.minute != minute1) {
    if (RTC.minute < 10) {
      tft.fillRect(99, 197, 27, 36, BLACK);
      tft.setCursor(100, 197);
      tft.print ("0");
      tft.fillRect(125, 197, 23, 36, BLACK); // x, y, Long , haut
      tft.setCursor(126, 197);
      tft.print (RTC.minute);
    }
    else
    {
      tft.fillRect(99, 197, 50, 36, BLACK); // x, y, Long , haut
      tft.setCursor(100, 197);
      tft.print (RTC.minute);
    }
  }

  //---------------------------------------------------------------------
  //Seconde Num
  if (RTC.second != second1) {
    if (RTC.second < 10) {
      tft.fillRect(166, 197, 23, 36, BLACK);
      tft.setCursor(167, 197);
      tft.print ("0");
      tft.fillRect(191, 197, 23, 36, BLACK); // x, y, Long , haut
      tft.setCursor(192, 197);
      tft.print (RTC.second);
    }
    else
    {
      tft.fillRect(166, 197, 50, 36, BLACK); // x, y, Long , haut
      tft.setCursor(167, 197);
      tft.print (RTC.second);
    }
  }

  second1 = RTC.second;
  minute1 = RTC.minute;
  hour1 = RTC.hour;
  jour1 = RTC.dow;

  tft.setCursor(81, 197);
  tft.print (":");

  tft.setCursor(147, 197);
  tft.print (":");

  /////Vers page réglage
  digitalWrite(0, HIGH);
  TSPoint p = ts.getPoint();
  digitalWrite(0, LOW);
  //pinMode(XP, OUTPUT);
  pinMode(XM, OUTPUT);
  pinMode(YP, OUTPUT);
  //pinMode(YM, OUTPUT);
  p.x = map(p.x, TS_MINX, TS_MAXX, tft.width(), 0);
  p.y = map(p.y, TS_MINY, TS_MAXY, tft.height(), 0);

  if (p.z > MINPRESSURE && p.z < MAXPRESSURE) {/////////////////////////////////////////////////////////////////::

    if (((p.x < 250) && (p.x > 150)) && ((p.y < 370) && (p.y >  250))) {
      tft.fillScreen(BLACK);
      (Reg = 2);
    }
  }
}

void Reglage()
{
  tft.setTextColor(GREEN);  tft.setTextSize(2);

  tft.setCursor(10, 5);
  tft.println(" <-- ");
  tft.setCursor(70, 25);
  tft.println("REGLAGES");
  tft.setCursor(80, 280);
  tft.println("< OK >");

  tft.setTextColor(CYAN);
  tft.setCursor(77, 60);
  tft.println("H  M  S");

  tft.setCursor(15, 170);
  tft.println(" Jour mois  annee");
  tft.setTextColor(RED);
  tft.setCursor(15, 190);
  tft.println("  +     +     +");
  tft.setCursor(15, 245);
  tft.println("  -     -     -");


  //// Réglage heure
  digitalWrite(0, HIGH);
  TSPoint p = ts.getPoint();
  digitalWrite(0, LOW);
  //pinMode(XP, OUTPUT);
  pinMode(XM, OUTPUT);
  pinMode(YP, OUTPUT);
  //pinMode(YM, OUTPUT);

  if (p.z > MINPRESSURE && p.z < MAXPRESSURE) {

    if (((p.x < 700) && (p.x > 600)) && ((p.y < 750) && (p.y >  600))) {
      tft.fillRect(70, 98, 22, 20, BLACK); // x, y, Long , haut
      RTC.hour ++;
      if (RTC.hour > 23) RTC.hour = 0;
    }

    if (((p.x < 700) && (p.x > 600)) && ((p.y < 610) && (p.y >  530))) {
      tft.fillRect(70, 98, 22, 20, BLACK); // x, y, Long , haut
      RTC.hour --;
      if (RTC.hour == 255) RTC.hour = 23;
    }

    ///// Réglage minutes

    if (((p.x < 570) && (p.x > 480)) && ((p.y < 710) && (p.y > 650))) {
      tft.fillRect(110, 98, 22, 20, BLACK); // x, y, Long , haut
      RTC.minute ++;
      if (RTC.minute > 59) RTC.minute = 0;
    }

    if (((p.x < 570) && (p.x > 480)) && ((p.y < 610) && (p.y > 530))) {
      tft.fillRect(110, 98, 22, 20, BLACK); // x, y, Long , haut
      RTC.minute --;
      if (RTC.minute == 255) RTC.minute = 59;
    }

    ///// Réglage secondes

    if (((p.x < 450) && (p.x > 350)) && ((p.y < 710) && (p.y > 650))) {
      tft.fillRect(150, 98, 22, 20, BLACK); // x, y, Long , haut
      RTC.second ++;
      if (RTC.second > 59) RTC.second = 0;
    }

    if (((p.x < 450) && (p.x > 350)) && ((p.y < 610) && (p.y > 530))) {
      tft.fillRect(150, 98, 22, 20, BLACK); // x, y, Long , haut
      RTC.second --;
      if (RTC.second == 255) RTC.second = 59;
    }

    ////Réglage jour
    if (((p.x < 810) && (p.x > 720)) && ((p.y < 440) && (p.y > 350))) {
      tft.fillRect(30, 213, 40, 22, BLACK); // x, y, Long , haut
      RTC.day ++;
      if (RTC.day > 31) RTC.day = 1;
    }

    if (((p.x < 810) && (p.x > 720)) && ((p.y < 300) && (p.y > 200))) {
      tft.fillRect(30, 213, 40, 22, BLACK); // x, y, Long , haut
      RTC.day --;
      if (RTC.day == 255) RTC.day = 31;
    }

    tft.setTextColor(YELLOW);
    tft.setCursor(35, 215);
    tft.println (RTC.day);

    ////Réglage mois

    if (((p.x < 580) && (p.x > 500)) && ((p.y < 430) && (p.y > 350))) {
      tft.fillRect(95, 213, 40, 22, BLACK); // x, y, Long , haut
      RTC.month ++;
      if (RTC.month > 12) RTC.month = 1;
    }

    if (((p.x < 580) && (p.x > 500)) && ((p.y < 300) && (p.y > 200))) {
      tft.fillRect(95, 213, 40, 22, BLACK); // x, y, Long , haut
      RTC.month --;
      if (RTC.month < 1) RTC.month = 12;
    }


    ////Réglage Année
    if (((p.x < 335) && (p.x > 235)) && ((p.y < 430) && (p.y > 350))) {
      tft.fillRect(155, 213, 65, 22, BLACK); // x, y, Long , haut
      RTC.year ++;
      if (RTC.year > 2100) RTC.year = 2000;
    }

    if (((p.x < 300) && (p.x > 250)) && ((p.y < 300) && (p.y > 200))) {
      tft.fillRect(155, 213, 65, 22, BLACK); // x, y, Long , haut;
      RTC.year --;
      if (RTC.year < 2000) RTC.year = 2100;
    }

  }
  ///////////////////////////////////////////////
  tft.setTextColor(RED);  tft.setTextSize(2);
  tft.setCursor(77, 75);
  tft.println("+  +  +");
  tft.setCursor(77, 125);
  tft.println("-  -  -");

  tft.setTextColor(YELLOW);  tft.setTextSize(2);
  tft.setCursor(70, 100);
  tft.print(RTC.hour);

  tft.setCursor(110, 100);
  tft.print(RTC.minute);

  tft.setCursor(150, 100);
  tft.println(RTC.second);

  tft.setCursor(35, 215);
  tft.println (RTC.day);

  tft.setCursor(105, 215);
  tft.println (RTC.month);

  tft.setCursor(165, 215);
  tft.println (RTC.year);

  ///// Vers page Marche

  // "Sort" = Sorties avec ou sans remise à l'heure
  if (((p.x < 600) && (p.x > 500)) && ((p.y < 200) && (p.y > 100))) (Sort = 0); //Mise à l'heure
  if (((p.x < 840) && (p.x > 750)) && ((p.y < 900) && (p.y > 750))) (Sort = 1); //sans

  if (p.z > MINPRESSURE && p.z < MAXPRESSURE) {
    if ((((p.x < 600) && (p.x > 500)) && ((p.y < 200) && (p.y > 100)))
        || (((p.x < 840) && (p.x > 750)) && ((p.y < 900) && (p.y > 750)))) {
      tft.fillScreen(BLACK);
      Reg = 1;
      second1 = 60;
      minute1 = 60;
      hour1 = 25;


      if (Sort == 0) { //Sortie avec mise à l'heure
        RTC.setTime();
      }


      ///////// ///// Cadran ////////////
      tft.fillCircle(120, 90, 60, tft.color565(208, 242, 255));
      tft.drawCircle(120, 90, 60, BLUE);
      tft.drawCircle(120, 90, 63, CYAN);
      tft.drawCircle(120, 90, 66, tft.color565(208, 242, 255));

      for (int x = 0; x < 12; x++) {
        Xs = 120 + (cos((x * 30) * rad) * 75);
        Ys = 90 + (sin((x * 30) * rad) * 75);
        tft.drawLine(120, 90, Xs, Ys, tft.color565(208, 242, 255));
      }

      for (int x = 0; x < 60; x++) {
        Xs = 120 + (cos((x * 6) * rad) * 65);
        Ys = 90 + (sin((x * 6) * rad) * 65);
        tft.drawLine(120, 90, Xs, Ys, tft.color565(208, 242, 255));
      }


      //tft.setCursor(120, 0);
      tft.setTextColor(CYAN);  tft.setTextSize(2);
      tft.setCursor(110, 5);
      tft.println("12");
      tft.setCursor(200, 83);
      tft.println("3");
      tft.setCursor(116, 170);
      tft.println("6");
      tft.setCursor(30, 82);
      tft.println("9");
    }
  }

}


void loop() {
  if (Reg == 1) Marche();
  if (Reg == 2) Reglage();


  Serial.print  (RTC.day);
  Serial.print  (";");
  Serial.print  (RTC.month);
  Serial.print  (";");
  Serial.println  (RTC.year);
  Serial.println  (RTC.dow);
}

